import { EntityBench, EntityDB} from './dependencies/doggy.js';
import { world } from "mojang-minecraft";

//All rights reserved @evil_makima on twitter.

EntityBench.register( "makima:copper_furnace", "Copper Furnace", {
	fuels: 2,
	inputs: [ 3 ],
	outputs: [ 4 ],
	upgrades: null
})
.registerEvent( "on_craft", entity => {
	entity.runCommand(`particle makima:red_fire ~ ~ ~`);
}, 3);

EntityBench.register( "makima:iron_furnace", "Iron Furnace", {
	fuels: 2,
	inputs: [ 3 ],
	outputs: [ 4 ],
	upgrades: null
})
.registerEvent( "on_craft", entity => {
	entity.runCommand(`particle makima:red_fire ~ ~ ~`);
}, 4);

EntityBench.register( "makima:amethyst_furnace", "Amethyst Furnace", {
	fuels: 2,
	inputs: [ 3 ],
	outputs: [ 4 ],
	upgrades: null
})
.registerEvent( "on_craft", entity => {
	entity.runCommand(`particle makima:red_fire ~ ~ ~`);
}, 4);

EntityBench.register( "makima:gold_furnace", "Gold Furnace", {
	fuels: 2,
	inputs: [ 3, 4],
	outputs: [ 5, 5],
	upgrades: null
})
.registerEvent( "on_craft", entity => {
	entity.runCommand(`particle makima:red_fire ~ ~ ~`);
}, 5);

EntityBench.register( "makima:diamond_furnace", "Diamond Furnace", {
	fuels: 2,
	inputs: [ 3, 4],
	outputs: [ 5, 6],
	upgrades: null
})
.registerEvent( "on_craft", entity => {
	entity.runCommand(`particle makima:red_fire ~ ~ ~`);
}, 6);

EntityBench.register( "makima:emerald_furnace", "Emerald Furnace", {
	fuels: 2,
	inputs: [ 3, 4],
	outputs: [ 5, 6],
	upgrades: null
}, 6)
.registerEvent( "on_craft", entity => {
	entity.runCommand(`particle makima:red_fire ~ ~ ~`);
});

var filter = {};
var _furnace = false;

EntityBench.register( "makima:netherite_furnace", "Netherite Furnace", {
	fuels: 2,
	inputs: [ 3, 4, 5, 6],
	outputs: [ 7, 8, 9, 10],
	upgrades: [ 11, 12, 13, 15]
}, 6)
.registerEvent( "on_craft", (entity) => {
	let { x, y, z} = entity.location;
	
	if(!filter[`${x}:${y}:${z}`])
		entity.runCommand(`particle makima:blue_fire ~ ~ ~`);
})
.registerUpgrade( "minecraft:ink_sac", {
	matching: (entity) => {
		let { x, y, z} = entity.location;
		
		filter[`${x}:${y}:${z}`] = true;
	},
	unmatched: (entity) => {
		let { x, y, z} = entity.location;
		
		filter[`${x}:${y}:${z}`] = null;
	}
})
.registerUpgrade( "makima:redstone_core", {
	matching: (entity) => {
		let instance = EntityBench.getInstance( entity );
		
		if(instance && instance.fantasy_name == "Netherite Furnace t3")
			EntityBench.setInstanceValue( entity, "fantasy_name", "Netherite Furnace t4");
		else if(instance && !instance.fantasy_name)
			EntityBench.setInstanceValue( entity, "fantasy_name", "Netherite Furnace t2");
		
		EntityBench.setInstanceValue( entity, "heat", 2);
	},
	unmatched: (entity) => {
		EntityBench.setInstanceValue( entity, "heat", 0);
		
		let instance = EntityBench.getInstance( entity );
		
		if(instance && instance.fantasy_name == "Netherite Furnace t2")
			EntityBench.setInstanceValue( entity, "fantasy_name", null);
		else if(instance && instance.fantasy_name == "Netherite Furnace t4")
			EntityBench.setInstanceValue( entity, "fantasy_name", "Netherite Furnace t3");
	}
})
.registerUpgrade( "makima:ender_core", {
	matching: (entity) => {
		EntityBench.setInstanceValue( entity, "multiplier", 2);
	},
	unmatched: (entity) => {
		EntityBench.setInstanceValue( entity, "multiplier", 1);
	}
})
.registerUpgrade( "makima:xp_core", {
	matching: (entity) => {
		EntityBench.setInstanceValue( entity, "xp", 3);
	},
	unmatched: (entity) => {
		EntityBench.setInstanceValue( entity, "xp", 0);
	}
})
.registerUpgrade( "makima:nether_core", {
	matching: (entity) => {
		let instance = EntityBench.getInstance( entity );
		
		if(instance && instance.fantasy_name == "Netherite Furnace t2")
			EntityBench.setInstanceValue( entity, "fantasy_name", "Netherite Furnace t4");
		else if(instance && !instance.fantasy_name)
			EntityBench.setInstanceValue( entity, "fantasy_name", "Netherite Furnace t3");
		
		if(EntityDB.getInt( entity, "fuel" ) == 0)
			EntityDB.setInt( entity, "fuel", 1);
	},
	unmatched: (entity) => {
		let instance = EntityBench.getInstance( entity );
		
		if(instance && instance.fantasy_name == "Netherite Furnace t3")
			EntityBench.setInstanceValue( entity, "fantasy_name", null);
		else if(instance && instance.fantasy_name == "Netherite Furnace t4")
			EntityBench.setInstanceValue( entity, "fantasy_name", "Netherite Furnace t2");
	}
});